2.1.1

* Documentation improvements and updates
* Fixed that the required string was appended to the label over and over due to localizer caching
* Fixed that the checkbox's `name` attribute was included in the attributes of the matching label element on boolean fields

2.1.0

* no changes

2.1.0.rc

* documentation improvements
* improved performance by caching of Formtastic's i18n lookups
* improved performance in production by checking for defined constants instead of catching the exception
* fixed arguments passed into fields_for being flattened one level too deep
* added an optional `index` that an inputs() block can access for use in labels and other HTML attributes

2.1.0.beta

* Added Rails 3.2 compatibility
* Added a new Actions DSL (f.actions, f.action) — see below for deprecation of the Buttons DSL
* Added new i18n_localizer configuration, allowing you to use your own localiser class instead of Formtastic::Localizer
* Added a hidden input before mutli-selects, to allow full clearing of the select (like we do for checkboxes)
* Added support for integers in a :collection for radio and check_boxes inputs
* Added support for time inputs with no current value to default render blank inputs rather than pre-selecting the current time
* Brought back the Form Generator from 1.2.x versions of Formtastic
* Added support for placeholder text on textareas (text inputs)
* Deprecated the Buttons DSL (f.buttons, f.commit_button) in favor of the new Actions DSL — see above
* Removed the previously deprecated :label_method, :value_method & :group_label_method options
* Removed the previously deprecated :as => :numeric
* Removed the previously deprecated inline_errors_for and related methods
* Removed the previously deprecated SemanticFormHelper and SemanticFormBuilder
* Fixed the behavior of :include_blank and :prompt options to be inline with Rails’
* Fixed that :input_html => { :multiple => true } did not force a single choice select into a multi choice
* Fixed date, time and datetime legend labels to correspond to the first visible input, rather than the first input (which may be hidden)
* Fixed that DateInput should treat fragments excluded from :order option as discarded
* Fixed that the :wrapper_html options could not be reused in the view (like in a with_options block) because they were modified by Formtastic
* Fixed numerous Mongoid and MongoMapper compatibility issues
* Fixed that we should be calculating the length of integer columns as bytes
* Fixed many inputs (date, datetime, time, checkboxes, select & boolean) that did not correctly use the :index option in fields_for
* Fixed Haml and Slim template indentation
* Fixed invalid html output for nested inputs with multiple siblings
* Fixed i18n keys with nested objects
* Many documentation fixes and improvements
* A few performance improvements

2.0.2

* Fixed that MongoMapper does not use `associations(method)`. `.associations` is an accessor.

2.0.1

* fixed that `:multiple => true` wasn't working when no association present

2.0.0

* Fixed that all check boxes were incorrectly checked if an Array was passed in to :collection 
* Improved README 
* Added form generator template for Slim template engine
* Added support for Proc conditions in collection_from_association
* Refactored commit button. Split it into a couple of different methods to make it easier to override.

2.0.0.rc5

* Changed perform_browser_validations and use_required_attribute configuration defaults from true to false for a better out-of-the-box experience and upgrade path
* Fixed that the `novalidate` attribute was being applied to the `<form>` tag when it shouldn't have been (and vice-versa)
* Fixed `undefined method `last' for #<Classname>` with a `:collection` containing an array of arrays

2.0.0.rc4

* Fixed that TimeInput was not rendering hidden y/m/d inputs by default.
* Fixed test suite under Rails 3.1.0.rc5
* Fixed false and blank fragment labels on date/time inputs producing unsafe HTML.
* Fixed that inputs were 'required' withput considering `:on => :create` validations
* Fixed that collections of strings in CheckBoxesInput were ot being correctly checked be checked if they match the model
* Fixed that the required attribute was added to the choices in a :radio or :check_boxes input, instead of just the parent input wrapper
* Fixed semantic_fields_for when used with a hash-like model
* Fixed that models without defined validations (even if validators_on exists) should not be considered required
* Fixed min/max attributes when the validation uses a Proc
* Fixed that inputs should not be considered required if :allow_blank => true is set on validates_inclusion_of
* Fixed that inputs should not be considered required if if either :allow_blank => true, :minimum is > 0, or :within's least value is > 0 is set on validates_length_of 
* Fixed a typo in the config template
* Fixed semantic_fields_for to work with Rails 3 *and* 3.1's method sigs (I hope), many thanks to the simple_form guys for figuring this out
* Changed HTML5 `step` attribute to default to "any" instead of "1"
* Added CarrierWave support for to file input detection
* Added a configuration 'perform_browser_validations' to opt out of HTML5 browser validations.
* Added more support for mongo documents, including MongoMapper-specific reflection capability
* Added IE specific stylesheets & moved those styles out of main stylesheet, include them yourself if needed
* Added a new configuration to opt out of HTML5 required attribute

2.0.0.rc3

* Fixed that .label class was incorrectly applied to <label> tags inside a .choice on radio and checkbox inputs (#599)

2.0.0.rc2

* Fixed install instructions in readme to reflect 2.0.0.rc1
* Fixed that the checkbox was mistakenly placed after the label text in BooleanInput, not before it as per 1.x (#591)
* Fixed that select inputs had two "blank" options at the top in some cases (#590)
* Added documentation for Timeish inputs (date, datetime, time) (#589)

2.0.0.rc1

* Removed the "inline_order" configuration (redefine input_wrapping instead)
* Removed the "special" implementation of label() from FormBuilder, so builder.label will call Rails' label helper, not ours
* Changed the HTML id attribute used for hidden inputs to be consistent with all other inputs
* Changed formtastic:form generator include the wrapping semantic_form_for block
* Changed formtastic:form generator to generate a partial by default (instead of copying to clipboard, which can be done with --copy)
* Removed formtastic_stylesheet_link_tag
* Improved some documentation, much more to come
* Tagged many modules as @private to remove from YARD documentation
* Added YARD as development dependency for a massive documentation effort
* Renamed Formtastic::SemanticFormHelper to Formtastic::Helpers::FormHelper (SemanticFormHelper still exists as a module which includes the new module, need to handle deprecation notices somehow)
* Renamed Formtastic::SemanticFormBuilder to Formtastic::FormBuilder (SemanticFormBuilder still exists as a subclass, need to handle deprecation notices somehow)
* Massive refactoring of formtastic.rb into around 30 files and modules like StringInput and ButtonsHelper
* Removed chunks of Rails 2 specific code, tests and documentation
* Added support for HTML5 required attribute on input, select and textarea tags
* Added support for HTML5 min/max/step attributes on NumericInput
* Added support for HTML5 placeholder attributes on Stringish inputs (string, email, phone, url, search, number, password)
* Added support for HTML5 autofocus attributes
* Changed nested inputs() blocks to be automatically wrapped in an `<li>` tag to preserve HTML validity
* Changed quick forms to skip polymorphic associations (they didn't work)
* Changed short hand forms to raise an error when trying to render an input for a polymorphic association (it didn't work, need a collection)
* Changed input() to raise an error when a :collection is not provided for a polymorphic association (we can't guess which class to use)
* Removed semantic_remote_form_for etc, the remote_form_for helpers don't exist in Rails 3
* Changed :label_method option to :member_label (with backwards compat and deprecation warnings)
* Changed :value_method option to :member_value (with backwards compat and deprecation warnings)
* Changed :grouped_label_method option to :grouped_label (with backwards compat and deprecation warnings)
* Added support for a Method objects to :member_label/:member_value (aka :label_method/:value_method)
* Improved support for Mongoid 
* Changed Rails dependency from ~> 3.0.0 to ~> 3.0 to allow experimentation with Rails 3.1 betas
* Removed some overly eager CSS resets on form elements that made Opera and FF inputs look pretty ugly
* Removed specificity and duplication in CSS
* Added many new classes to DOM elements to enable more efficient and descriptive CSS
* Improved visual/spacing consistency in checkboxes
* Added non-standard zoom:1; to clearfixes to support IE better
* Changed CSS coding style to multi-line so we can annotate the styles better
* Fixed that overly specific CSS rules weren't applied to nested form elements properly
* Removed formtastic:form generator and changed formtastic:install generator
to override scaffold generator
* Refactored and consolidated CSS by adding extra class names into the mark-up, preferring to style by class instead of element wherever possible
* Added IE6 and IE7 stylesheets for specific fixes if needed (uncomplicates formtastic.css)
* Added support for Rails 3.1 asset pipeline as well as previous generated CSS for Rails < 3.1
* Made many subtle visual improvements to CSS, especially in IE

1.2.4

* no changes

1.2.4.beta2

* Changed :boolean inputs to use Rails' check_box_checked? instead of our own logic
* Changed developer instructions in README
* Fixed :boolean inputs to disable the included hidden input when disabling the actual checkbox
* Fixed that Formtastic was making changes to the options hash directly instead of on a duplicate, causing problems for those trying to reuse options on multiple inputs in the view 
* Fixed that tiny scroll bars were appearing on legends in date/time/radio/cbheckboxes fielsets (GH-477)    
* Fixed an issue when formtastic fails to determine if a checkbox is checked with custom checked and unchecked values (thanks to Eugene Bolshakov)
* Fixed that the hidden input rendered with a boolean checkbox did nt use the custom :name from :input_html options hash
* Fixed issue where Firefox 4 gives focus to the <li> wrapper (fixes #524).
* Fixed that a shared input options hash could not be re-used in the view without being altered by each input
* Improved compatibility with Mongoid Documents
* Updated i18n dependency to ~> 0.4

1.2.4.beta

* Changed :boolean inputs to use Rails' check_box_checked? instead of our own logic
* Changed developer instructions in README
* Fixed :boolean inputs to disable the included hidden input when disabling the actual checkbox
* Fixed that Formtastic was making changes to the options hash directly instead of on a duplicate, causing problems for those trying to reuse options on multiple inputs in the view
* Fixed that tiny scroll bars were appearing on legends in date/time/radio/cbheckboxes fielsets (GH-477)
* Fixed an issue when formtastic fails to determine if a checkbox is checked with custom checked and unchecked values (thanks to Eugene Bolshakov)
* Fixed that the hidden input rendered with a boolean checkbox did nt use the custom :name from :input_html options hash

1.2.3

* Removed deprecated methods input_field_set, button_field_set, boolean_select_input, boolean_radio_input and boolean_radio_input
* Removed deprecated :class option on commit_button (use :input_html instead)
* Fixed that stylesheets and initializers directories would be removed on uninstalling
* Fixed some documentation and formatting
* Fixed test coverage issues under Ruby 192 and Rails 2
* Fixed that input_html options were not being passed down to checkbox tags
* Changed internal duplication of the options hash so that the same options hash can be re-used over multiple inputs without being altered
* Changed internal configuration to use class_attribute when available (Rails 3) to avoid deprecation warnings
* Added Rails 3 compatible form generator templates in addition to existing Rails 2 support
* Added reflection on allow_blank option when determining the 'required' status of an input


1.2.2

* Removed deprecated aliased input names (:as => :boolean_select, :as => :boolean_radio_input
* Removed deprecated aliased method names (input_field_set, button_field_set)
* Removed deprecated :class => 'whatever' on commit_button
* Fixed that classes in :button_html were being merged into :wrapper_html
* Fixed that :include_blank was being ignored (always false) for multi selects
* Fixed that we should reflect on allow_blank option to determine required status with validates_inclusion_of
* Added the ability to pass :input_html options be passed to the checkbox on a boolean input
* Developers: Added bundler support to for developer/contribution
* Developers: Fixed spec coverage under Rails 2 and Ruby 1.9.2

1.2.1

* test suite compatibilities with Rails 3.0.3

1.2.1.beta3

* Fixed bad merge related to :boolean inputs in 1.2.1.beta

1.2.1.beta2

* Fixed typos in gemspec post-install message

1.2.1.beta

* Fixed that unchecking :boolean inputs would not send the correct params (and not persist the change the the DB)
* Fixed that :boolean inputs checked state was not reflecting the database/model value
* Fixed that init.rb and rails/init.rb were not included in the gem (affecting Rails 2)

1.2.0

* Changed default_text_area_width to nil, overlooked in recent CSS/width changes
* Improved documentation

1.2.0.beta2

* Added :wrapper_html functionality to commit_button() to match what input() does
* Deprecated the :class option on commit_button(), use :wrapper_html instead
* Added hpricot as missing development dependency
* Improved documentation

1.2.0.beta

* New Stuff

  * Added support for Paperclip's questionable use of multiple error keys on a single attribute, so errors on Paperclip :file inputs Just Work
  * Added ability for the error and hint class to be overridden with :hint_class and :error_class, and configurable defaults app-wide
  * Added basic support for multiple forms in the same document by allowing the element ids to be prefixed with the :namespace option on semantic_form_for
  * Added a fallback to Rails' helpers.label key if Formtastic label translation are not found
  * Added support for default_text_area_width
  * Added support for #persisted? over #new_record? (ActiveModel)
  * Added the 'required' logic to attributes with validates_inclusion_of validation, in addition to validates_presence_of
  * Added new HTML5 :as => :email input (Rails 3)
  * Added new HTML5 :as => :phone input (Rails 3)
  * Added new HTML5 :as => :search input (Rails 3)
  * Added new HTML5 :as => :url input (Rails 3)
  * Added the ability for the :collection option to accept a string of HTML (like the output from grouped_options_for_select), rather than just Arrays, Hashes, collections, etc.
  * Added the ability to set your own form class, instead of 'formtastic'
  * Added maxlength attributes to inputs if it can be determined via the ValidationReflection plugin or ActiveModel validation reflections
  * Added the ability to override the form class (Post => "post") through an :as option on semantic_form_for option
  * Added the ability to customize the order for specific types of inputs. This is configured on a type basis and if a type is not found it willfall back to the default order as defined by @@inline_order
  * Added :first as a new rendering choice for the errors on each input
  * Added custom_inline_order to allow inline ordering per input type
  * Added the ability to override the generator templates in Rails 3

* Fixes

  * Fixed invalid HTML generated by Rails' hidden inputs on checkboxes (by rendering our own hidden tag in a more deliberate place)
  * Fixed a bunch of invalid i18n key defaults
  * Fixed that 'required' classes and logic were not being applied to :check_boxes and :radio inputs
  * Fixed CSS bugs around Firefox's quirks with form elements that resulted in overflow/scroll bar issues
  * Fixed that errors on fields with association were not marking the wrapping tag with the error class
  * Fixed CSS where FF was displaying extra scroll bars on .check_boxes and .radio inputs (and the choices within them)

* Changes

  * Changed that we were defaulting to a :select input for columns ending in _id, instead of columns with an appropriate associations
  * Deprecated a bunch of aliased method names that should no longer be used
  * Removed deprecated :selected, :checked and :default options
  * Changed the width styling for string, numeric, password and other basic inputs, defaults to 75% unless the size attribute is present
  * Changed string, numeric, password and other basic inputs' default text field size config to nil instead of 50, meaning the size attribute will be ommitted from most inputs, makeing styling easier, and custom sizes with the size attribute more deliberate
  * Changed string, numeric, password and other basic inputs to no longer add the size attribute based on column information (the default config is applied, unless it's nil)
  * Changed text input css behaviour updated to be similar to string etc
  * Changed text inputs to no longer include a default cols attribute, specify it with :input_html if you need it, but the value we were using was useless... also beefed up spec coverage
  * Removed :label calls from the generated ERB in the form generator (i18n is preferred)
  * Changed that :select inputs for HABTM associations would ignore the :include_blank option
  * Changed the default method on collections from Model.find(:all) to Model.all
  * Removed the deprecated formtastic_stylesheets generator
  * Changed the minimum Rails version to 2.3.7, which the earliest version which the specs pass with
  * Changed :password inputs to be sized by percentage (like other string-ish inputs), rather then em-based

1.1.0

* documentation changes only

1.1.0.beta [Specs passed against Rails 2.3.8, 3.0.0.rc & 3.0.0]

* Changed semantic_remote_form_for to allow for unobstrusive javascript / :remote option (rails3)
* Changed spec_helper to support Rails 2 with RSpec or Rails 3 with RSpec 2 environments
* Changed Rakefile to initalize the correct testing framework for the enviroment
* Changed i18n dependency to >= 0.4
* Fixed use of model_name.human instead of model_name.human_name (rails3)
* Fixed use of deprecated Errors#on_base
* Fixed use of ActionController::RecordIdentifier#singular_class_name (rails3)
* Added railtie to perform initialization tasks after the rails framework is available (rails3)
* Added compatible install and form helpers (rails3)
* Added support for ActiveModel Validations, thanks to Guillaume Belleguic (rails3)

1.0.1

* fixed "already initialised constant" warnings on boot

1.0.0

* nothing changed from rc2

1.0.0.rc2

* Fixed that :label=>false didn't disable the label on checkboxes/radiobuttons (#331)
* Added full support of :input_html options for hidden fields

1.0.0.rc

* Fixed that :checked_value and :unchecked_value options were being passed down into the HTML tags as attributes

1.0.0.beta4

* ensure i18n < 0.4 is listed as a dependency in the gemspec

1.0.0.beta3

* Added :ignore_date option to time inputs (#308)
* Fixed inputs_for_nested_attributes returning out of the proc on has_many associated nested models.
* Fixed with_custom_field_error_proc to use ensure for restoring default field_error_proc and to store it in a local variable instead of in a class variable (nested calls were problematic due to the globalness of class variables)

1.0.0.beta2

* Added default escaping of html entities in labels and hints (#292, #299)
* Added/Fixed that :value_method and :label_method were not being used for simple collections (like Arrays)
* Added some more compatibility for Mongooid and other ORMs by checking for reflection information before calling it
* Fixed deprecation warnings in Rails 2.3.6 and newer
* Fixed a bug where :check_boxes and :radio were using method instead of :label option
* Fixed a conflict where i18n lookups were failing when an attribute and model have the same name
* Fixed some html that was not marked as safe

1.0.0.beta

* Fixed :radio and :check_boxes inputs so that the legend no longer includes a <label> with a `for` attribute pointing to an input that doesn't exist (#253)
* Fixed that some inputs had invalid 'find_options' attribute (#262)
* Fixed that we were calling html_safe! when it was not always available
* Added the ability for :input_html to now accept an option of :size => nil, to exclude the :size attribute altogether (#267)

0.9.10

* Fixed i18n incompatibility with Rails 2.3.8 by reverting two i18n patches pulled in from the rails3 branch

0.9.9

* Changed date/time inputs to default to nil instead of Time.now when the object has no value (due to deprecation warning, #240)
* Changed the behaviour of associations with a :class_name option to be more consistent with what Rails expects
* Fixed issues relating to Rails 2.3.6 automatically escaping ERB
* Fixed issues with Ruby 1.9.1 and Haml
* Fixed use of deprecated {{key}} syntax in i18n interpolation (thanks to Hans Petter Wilhelmsen)
* Added the :disabled option to check_boxes input
* Added translation support for nested models (thanks to Toni Tuominen)

0.9.8

* Deprecated :selected/:checked options, see http://wiki.github.com/justinfrench/formtastic/deprecation-of-selected-option
* Changed CSS rules for fieldset lists to be more specific
* Changed that radio and checkbox inputs used to associate the legend label with the first choice's input (#101)
* Changed the generators to use |f| rather than |form| (#151)
* Changed the behaviour of :selected/:checked options to address several bugs and inconsistencies (#152)
* Changed CSS for input width property to max-width, allowing a size attribute to still be set
* Fixed an issue where label_str_method not honoured if the object is an ActiveRecord object
* Fixed incorrect html class for namespaced objects ("/" replaced with "_")
* Fixed compatibility issue with SearchLogic (#155)
* Fixed an issue where label_str_method was not being overridden with i18n
* Fixed a button text issue with Rails 2.x in which human_name on multi-word models returned one word (eg Ticketrequest) (#153)
* Fixed the behaviour of select inputs when the belongs_to or has_many association has a special :class_name option
* Fixed line numbers from eval'd code, to help when debugging
* Fixed CSS issue that hidden fields were not always hidden (Chrome for example) (#209)
* Fixed and improved CSS with nested fieldsets and legends
* Fixed date/time inputs where :include_seconds => true
* Fixed that inline hints were still being rendered on hidden inputs
* Fixed broken CSS declaration missing a colon
* Added configuration preferences for row and column attributes on textareas
* Added semantic_errors helper and CSS (for all errors on an object)
* Added :filename to the list of @@file_methods, to support carrierwave plugin (#156)
* Added a Formtastic::LayoutHelper with formtastic_stylesheets helper method for linking to all Formtastic CSS files
* Added labels option to date/time/datetime fields to customise the label of each part of the set (year, month, etc)
* Added many improvements to the README and docs
